/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.gebietsbaum.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class GebietsgruppierungTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String gebietsgruppierungArt;
    public java.lang.String getGebietsgruppierungArt(){
      return gebietsgruppierungArt;
    }
    protected final java.lang.String name;
    public java.lang.String getName(){
      return name;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlTK wahlTK;
    public de.ivu.elect.business.wahl.entity.WahlTK getWahlTK(){
      return wahlTK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlterminTK wahlterminTK;
    public de.ivu.elect.business.wahl.entity.WahlterminTK getWahlterminTK(){
      return wahlterminTK;
    }

  public GebietsgruppierungTK(
java.lang.String gebietsgruppierungArt
, java.lang.String name
,   de.ivu.elect.business.wahl.entity.WahlTK wahlTK
,   de.ivu.elect.business.wahl.entity.WahlterminTK wahlterminTK
  ) {
    super();


      this.gebietsgruppierungArt = gebietsgruppierungArt;
      this.name = name;
        this.wahlTK = wahlTK;
      this.wahlterminTK = wahlterminTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((gebietsgruppierungArt == null) ? 0 : gebietsgruppierungArt.hashCode());
                    result = result + ((name == null) ? 0 : name.hashCode());
        
                    result = result + ((wahlTK == null) ? 0 : wahlTK.hashCode());
                    result = result + ((wahlterminTK == null) ? 0 : wahlterminTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof GebietsgruppierungTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        GebietsgruppierungTK other = (GebietsgruppierungTK) obj;

                if (gebietsgruppierungArt == null) {
          if (other.gebietsgruppierungArt != null) {
            return false;
          }
        } else if (!gebietsgruppierungArt.equals(other.gebietsgruppierungArt)) {
          return false;
        }
                if (name == null) {
          if (other.name != null) {
            return false;
          }
        } else if (!name.equals(other.name)) {
          return false;
        }
        
                if (wahlTK == null) {
          if (other.wahlTK != null) {
            return false;
          }
        } else if (!wahlTK.equals(other.wahlTK)) {
          return false;
        }
                if (wahlterminTK == null) {
          if (other.wahlterminTK != null) {
            return false;
          }
        } else if (!wahlterminTK.equals(other.wahlterminTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return GebietsgruppierungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlTK.getAllEntityFieldValues());
    result.addAll(wahlterminTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(GebietsgruppierungConstants.MESSAGE_KEY_ENTITY_EINZAHL, GebietsgruppierungConstants.MESSAGE_KEY_GEBIETSGRUPPIERUNG_ART_EINZAHL, gebietsgruppierungArt));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(GebietsgruppierungConstants.MESSAGE_KEY_ENTITY_EINZAHL, GebietsgruppierungConstants.MESSAGE_KEY_NAME_EINZAHL, name));
        
        return result;
      }


            @Override
            public String toString() {
            return "GebietsgruppierungTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"gebietsgruppierungArt="+gebietsgruppierungArt
                            +", name="+name
                                        +", wahlTK="+wahlTK
                            +", wahlterminTK="+wahlterminTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(GebietsgruppierungConstants.MESSAGE_KEY_GEBIETSGRUPPIERUNG_ART_EINZAHL) + "=" +

                                    gebietsgruppierungArt
                
                          + ", " + messages.getMessageForMessageKey(GebietsgruppierungConstants.MESSAGE_KEY_NAME_EINZAHL) + "=" +

                                    name
                
                                      + ", " +  toStringLokalisiert(wahlTK, messages)
                          + ", " +  toStringLokalisiert(wahlterminTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Gebietsgruppierung> java.util.Map<GebietsgruppierungTK, E> mappeGebietsgruppierungNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Gebietsgruppierung::getGebietsgruppierungTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Gebietsgruppierung, GebietsgruppierungTK> getGebietsgruppierungToTKFunction() {
                return Gebietsgruppierung::getGebietsgruppierungTK;
                }

}
